# GitLab Performance Tool

The GitLab Performance Tool (`gpt`) is built and maintained by the GitLab Quality Enablement team to provide performance testing of any GitLab instance. The tool has been built upon the industry leading open source tool [k6](https://k6.io) and provides numerous tests that are designed to effectively performance test GitLab.

The tool can be used both manually and automatically, with us doing the latter for automated testing of reference environments via [Pipelines](https://docs.gitlab.com/ee/ci/pipelines/schedules.html).

GPT is used by the GitLab Quality Enablement team to continuously performance test GitLab on environments based on our [Reference Architectures](https://docs.gitlab.com/ee/administration/reference_architectures/) that have been built with the [GitLab Environment Toolkit](https://gitlab.com/gitlab-org/gitlab-environment-toolkit). For more information please refer to our blog post - [How our QA team leverages GitLab’s performance testing tool (and you can too)](https://about.gitlab.com/blog/2020/02/18/how-were-building-up-performance-testing-of-gitlab/).

## Documentation

Documentation on how to use the tool can be found in the [`docs/`](docs/README.md) folder:

For those looking to get started quickly, check out our [Quick Start Guide](docs/quick_start.md).

For detailed information about using the GitLab Performance Tool, please refer to:

* [Preparing the Environment](docs/environment_prep.md)
* [Running the Tests](docs/k6.md)

## Test Details

To get more detailed information about the current test list that is run by GPT you can refer to the [Current Test Details wiki page](https://gitlab.com/gitlab-org/quality/performance/wikis/current-test-details).

## Test Results

The GitLab Quality team uses this Tool in frequent automated pipelines to continuously measure the performance of GitLab. The results are uploaded to this project's wiki and made available for anyone to see:

* Test runs against reference environments - https://gitlab.com/gitlab-org/quality/performance/wikis/Benchmarks/Latest
